.nolist
#include "ion.inc"
;I suppose sram stands for safe ram, but i dunno how much of it i can use
ballxpos   = sram+14
ballypos   = sram+34
ballh      = sram+54   ;Horizontal movement
ballv      = sram+74   ;Vertical   movement
ballspd    = sram+94   ;number of pixels to move per 2 loops
playerx    = sram+1
playery    = sram+2
nibblex    = sram+3
nibbley    = sram+4
alive      = sram+5    ;1=alive, 0-dead
level      = sram+6    ;number of balls
score      = sram+7
invul      = sram+8    ;couter till you can be killed
timer      = sram+9    ;the loop timer keeper to control ballspd
loop       = sram+10   ;1=loop again, 0=don't
bullettime = sram+11   ;how slow to delay it
temp       = sram+12
.list
#ifdef TI83P                ;\
    .ORG progstart-2        ; \
    .DB $BB,$6D             ;  \
                            ;   \
#else                       ;    \Basic Header
    .ORG progstart          ;    /
#endif                      ;   /
    RET                     ;  /
    JR NC,start             ; /
    .DB "Dodgeball",0       ;/Name displayed in ION
start:
;The number of balls (1-20)
    LD    A, 10
    LD    (level), A
;Title Screen
    BCALL (_homeUp)
    BCALL (_clrlcdfull) ;Clear everything
    RES   AppAutoScroll, (IY +  AppFlags)  ;Don't want autoscroll
    SET   textinverse, (iy+textflags)      ;Set the text to be inversed
    LD    HL, titlescreen1                 ;Loads address into HL
    BCALL (_putS)                          ; to be displayed
    RES   textinverse, (iy+textflags)      ;Set the text to be un-inversed
    LD    HL, titlescreen2                 ;Loads address into HL
    BCALL (_putS)                          ; and displays it
    LD    HL, $0004
    LD    (CurRow), HL
    LD    A, (highscore)                   ;load the value of highscore into HL
    LD    HL, 0
    LD    L, A
    BCALL (_DispHL)                        ;to display it

beginwait:
    BCALL (_GetCSC)
;checks [clear]
    CP    $0F
    JR    Z, exit2
;checks [2nd]
    CP    $36
    JP    Z, setup
;checks [mode]
    CP    $37
    JP    Z, options
    JR    beginwait
exit2:
    SET   AppAutoScroll, (IY +  AppFlags)       ;Make it so it will scroll again
    RET
options:
    BCALL (_homeUp)
    BCALL (_clrlcdfull) ;Clear everything
    SET   textinverse, (iy+textflags)      ;Set the text to be inversed
    LD    HL, titlescreen1                 ;Loads address into HL
    BCALL (_putS)                          ; to be displayed
    RES   textinverse, (iy+textflags)      ;Set the text to be inversed
    LD    HL, $0005
    LD    (CurRow), HL
    LD    HL, txt_options
    BCALL (_putS)
    LD    HL, $0005
    LD    (CurRow), HL
    LD    HL, txt_options
    BCALL (_putS)
options2:
    CALL  OptMenu
options_loop:
;checks left and right arrows
    BCALL (_GetCSC)
    CP    0Fh
    JP    Z, exit2       ;Clear to exit
    CP    36h
    JR    Z, setup       ;Clear to exit
    CP    02h
    JR    Z, dec_level
    CP    03h
    JR    Z, inc_level
    JR    options_loop

dec_level:
    LD    A, (level)
    CP    1
    JR    Z, options_loop
    LD    HL, level
    DEC   (HL)
    CALL  OptMenu
    JR    options_loop
inc_level:
    LD    A, (level)
    CP    20
    JR    Z, options_loop
    LD    HL, level
    INC   (HL)
    CALL  OptMenu
    JR    options_loop

setup:
    LD    A, 1
    LD    (alive), A    ;That the player is alive
    LD    (loop), A     ;loop
    LD    (temp), A
    LD    A, 255
    LD    (invul), A    ;The amount of loops invuln (1-255)


    XOR   A
    LD    (bullettime), A ;BulletTime
    LD    (timer), A      ;Timer
    LD    (score), A      ;Score


;Setting up the ball properties
    LD    A, (level)      ;Loads how many times it will loop
    LD    B, A            ;into reg B because I use DJNZ
initloop:
    PUSH  BC              ;I don't want to lose the count of the loop
    LD    DE, 0           ;Reset DE
    LD    E, B            ;Load the number loop this is
    DEC   E               ;Decrease it by one
;Random X position
    LD    HL, ballxpos
    ADD   HL, DE
    LD    B, 74
    CALL  ionRandom
    ADD   A, 7
    LD    (HL), A
;Random Y position
    LD    HL, ballypos
    ADD   HL, DE
    LD    B, 45
    CALL  ionRandom
    ADD   A, 7
    LD    (HL), A
;Random H direction
    LD    HL, ballh
    ADD   HL, DE
    LD    B, 2
    CALL  ionRandom
    DEC   A
    LD    (HL), A
    CP    0
    CALL  NZ, noMore

;Random V direction
    LD    HL, ballv
    ADD   HL, DE
    LD    B, 2
    CALL  ionRandom
    DEC   A
    LD    (HL), A
    CP    0
    CALL  NZ, noMore

;Set the speed to 2 for now
    LD    HL, ballspd
    ADD   HL, DE
    LD    A, 2
    LD    (HL), A
;See if we need to go onto the next
;If it is moving diagonally, then it must move slower
    LD    HL, ballh
    ADD   HL, DE
    LD    A, (HL)
    CP    0
    JR    Z, initloop2
    LD    HL, ballv
    ADD   HL, DE
    LD    A, (HL)
    CP    0
    JR    Z, initloop2
    LD    HL, ballspd
    ADD   HL, DE
    LD    A, 1
    LD    (HL), A
    XOR   A
    LD    (temp), A
initloop2:
    POP   BC
    LD    A, (loop)
    CP    1
    CALL  Z, incB
    LD    A, 1
    LD    (loop), A
    DJNZ  initloop
    JR    setupdone
noMore:
    XOR   A
    LD    (loop), A
    RET
incB:
    INC   B
    RET
setupdone:
;Make sure at least one is diagonal
    LD    A, (temp)
    CP    1
    JP    Z, Setup

    XOR   A      ;Set the player position
    LD    (playerx), A  ;to 0
    LD    (playery), A
    CALL  newNibble     ;Now to make up a nibble

;Now the game begins
;Clearing the screens
    BCALL (_clrlcdfull) ;Clear everything
    BCALL (_cleargbuf)
mainLoop:
;[2nd] toggles bullettime
    BCALL (_GetCSC)
    CP    35h
    CALL  Z, toggle_bt1     ;speed 1
    CP    34h
    CALL  Z, toggle_bt2     ;speed 2
    CP    33h
    CALL  Z, toggle_bt3     ;speed 3
    CP    32h
    CALL  Z, toggle_bt4     ;speed 4
    CP    31h
    CALL  Z, toggle_bt5     ;speed 5
    CP    0Fh
    JR    Z, dead       ;Clear to exit

    CALL  sprites        ;Draws the players and balls onto the buffer
    CALL  ionFastCopy    ;Copys it to the screen
    CALL  sprites        ;Erases it for next time

    LD    B, 20
    LD    A, (level)
    SUB   B
    CP    0
    CALL  NZ, delay3

    CALL  calculations   ;Checks Collisions
    LD    A, (invul)
    CP    0
    CALL  NZ, invincibility

    LD    A, (alive)     ;See if the calculations calculated
    CP    0              ;that the player is dead
    JR    Z, dead
    CALL  playermove     ;See what arrow keys are pressed
    CALL  bullet

    XOR   A
    LD    (loop), A
    CALL  playernib      ;Checks if the player is hitting the nibble
    LD    A, (loop)      ;If it is, then loop is set to 1
    CP    1
    CALL  Z, AddScore    ;Add a new score and setup a new nibble
    LD    A, (score)
    CP    254
    JR    Z, dead

;odd/even timer
    LD    A, (timer)
    INC   A
    LD    (timer), A
    CP    3
    JR    NZ, mainLoop

    LD    A, 1
    LD    (timer), A
    JR    mainloop

newhs:
    SET   textinverse, (iy+textflags)
    LD    HL, $0001
    LD    (CurRow), HL
    LD    HL, txt_new
    BCALL (_PutS)
    RES   textinverse, (iy+textflags)
    LD    A, (score)
    LD    (highscore), A
    RET
dead:
    LD    A, 1
    LD    (loop), A

    LD    HL, $0000
    LD    (CurRow), HL
    LD    HL, txt_score
    BCALL (_PutS)

    LD    HL, $0A00
    LD    (CurRow), HL
    LD    A, (score)
    LD    HL, 0
    LD    L, A
    BCALL (_DispHL)     ;Display player score

    LD    HL, $0A01
    LD    (CurRow), HL
    LD    A, (highscore)
    LD    HL, 0
    LD    L, A
    BCALL (_DispHL)     ;Display highscore

    LD    HL, $0003
    LD    (CurRow), HL
    LD    HL, txt_author
    BCALL (_PutS)
    LD    HL, $0304
    LD    (CurRow), HL
    LD    HL, txt_author2
    BCALL (_PutS)
    LD    HL, $0005
    LD    (CurRow), HL
    LD    HL, txt_endkeys
    BCALL (_putS)

;Check too see if it is a high score
    LD    A, (highscore)
    LD    B, A
    LD    A, (score)
    CP    B
    JR    C, exitloop
    CALL  NZ, newhs

exitloop:
    BCALL (_GetCSC)
;checks [clear]
    CP    $0F
    JR    Z, ReallyEnd
;checks [2nd]
    CP    $36
    JP    Z, setup
;checks [mode]
    CP    $37
    JP    Z, options
    JR    exitloop
ReallyEnd:
    SET   AppAutoScroll, (IY +  AppFlags) ;Don't want calculator to mess up
    RET

noloopagain:
    XOR   A
    LD    (loop), A
    RET

AddScore:
    LD    A, (score)
    INC   A
    LD    (score), A
    CALL  newNibble
    RET

sprites:
;Displaying the balls
    LD    A, (level)
    LD    B, A
sloop:
    PUSH  BC
    LD    DE, 0
    LD    E, B
    DEC   E
    LD    B, 5
    LD    HL, ballxpos
    ADD   HL, DE
    LD    A, (HL)
    LD    C, A
    LD    HL, ballypos
    ADD   HL, DE
    LD    A, (HL)
    LD    L, A
    LD    A, C
    LD    IX, s_ball
    CALL  myPutSprite
    POP   BC
    DJNZ  sloop
;Displaying the player
    LD    B, 7
    LD    A, (playery)
    LD    L, A
    LD    A, (playerx)
    LD    IX, s_player
    CALL  myPutSprite
;Displaying the nibble
    LD    B, 7
    LD    A, (nibbley)
    LD    L, A
    LD    A, (nibblex)
    LD    IX, s_nibble
    CALL  myPutSprite
    RET

    RET

directionals:
    XOR   A
    LD    (loop), A
    LD    HL, ballspd
    ADD   HL, DE
    LD    A, (HL)
    CP    2
    JR    Z, spdclear
    LD    B, A
    LD    A, (timer)
    CP    B
    RET   Z
spdclear:
;X position
    LD    HL, ballh
    ADD   HL, DE
    LD    A, (HL)
    LD    B, A
    LD    HL, ballxpos
    ADD   HL, DE
    LD    A, (HL)
    ADD   A, B
    LD    (HL), A
;Y position
    LD    HL, ballv
    ADD   HL, DE
    LD    A, (HL)
    LD    B, A
    LD    HL, ballypos
    ADD   HL, DE
    LD    A, (HL)
    ADD   A, B
    LD    (HL), A
;See if the ball needs to horizontally change
    LD    HL, ballxpos
    ADD   HL, DE
    LD    A, (HL)
    CP    0
    JR    Z, changeright
    CP    91
    JR    Z, changeleft
afterh:
;See if the ball needs to vertically change
    LD    HL, ballypos
    ADD   HL, DE
    LD    A, (HL)
    CP    0
    JR    Z, changedown
    CP    59
    JR    Z, changeup
afterv:
    RET
changeright:
    LD    HL, ballh
    ADD   HL, DE
    LD    A, 1
    LD    (HL), A
    JR    afterh
changeleft:
    LD    HL, ballh
    ADD   HL, DE
    LD    A, -1
    LD    (HL), A
    JR    afterh
changeup:
    LD    HL, ballv
    ADD   HL, DE
    LD    A, -1
    LD    (HL), A
    JR    afterv
changedown:
    LD    HL, ballv
    ADD   HL, DE
    LD    A, 1
    LD    (HL), A
    JR    afterv

calculations:
    LD    A, (level)
    LD    B, A
calcloop:
    PUSH  BC
    LD    DE, 0
    LD    E, B
    DEC   E

    CALL  directionals   ;Moves the balls

;Checking for collision with player
 ;X coord
    LD    HL, ballxpos
    ADD   HL, DE
    LD    A, (HL)
    ADD   A, 3
    LD    B, A
    LD    A, (playerx)
    ADD   A, 4
    SUB   B
    BIT   7, A
    CALL  NZ, positivize
    LD    HL, 0
    LD    B, A
    LD    L, A
    PUSH  DE
    LD    E, A
hloop:
    ADD   HL, DE
    DJNZ  hloop
    POP   DE
    LD    (temp), HL
 ;Y coord
    LD    HL, ballypos
    ADD   HL, DE
    LD    A, (HL)
    ADD   A, 3
    LD    B, A
    LD    A, (playery)
    ADD   A, 4
    SUB   B
    BIT   7, A
    CALL  NZ, positivize
    LD    HL, 0
    LD    B, A
    LD    L, A
    PUSH  DE
    LD    E, A
vloop:
    ADD   HL, DE
    DJNZ  vloop
    POP   DE
    EX    DE, HL
    LD    HL, (temp)
    ADD   HL, DE
    LD    A, H
    CP    0
    JR    NZ, nodeath
    LD    A, L
    CP    36
    CALL  C, SetDeath
nodeath:
    POP   BC
    DJNZ  calcloop
positivize:
    NEG
    RET
SetDeath:
    XOR   A
    LD    (alive), A
    RET
playermove:
;checks [arrow keys]
    LD    C, 1
    LD    A, $FE
    NOP
    NOP
    OUT   (C), A
    IN    B, (C)
    BIT   0, B
    CALL  Z, moveDown
    BIT   1, B
    CALL  Z, moveLeft
    BIT   2, B
    CALL  Z, moveRight
    BIT   3, B
    CALL  Z, moveUp
    RET
moveDown:
    LD    A, (playery)
    CP    57
    RET   Z
    INC   A
    LD    (playery), A
    RET
moveLeft:
    LD    A, (playerx)
    CP    0
    RET   Z
    DEC   A
    LD    (playerx), A
    RET
moveRight:
    LD    A, (playerx)
    CP    89
    RET   Z
    INC   A
    LD    (playerx), A
    RET
moveUP:
    LD    A, (playery)
    CP    0
    RET   Z
    DEC   A
    LD    (playery), A
    RET

invincibility:
    LD    HL, invul
    DEC   (HL)
    LD    A, 1
    LD    (alive), A
    RET

newNibble:
    XOR   A
    LD    (loop), A
;Random X position
    LD    B, 89

    CALL  ionRandom
    LD    (nibblex), A
;Random Y position
    LD    B, 57
    CALL  ionRandom
    LD    (nibbley), A
    CALL  NibCheck
    LD    A, (loop)
    CP    1
    JR    Z, newNibble
    RET

NibCollide:
    LD    A, 1
    LD    (loop), A
    RET

NibCheck:
    LD    A, (level)
    LD    B, A
NibLoop:
    PUSH  BC
    LD    DE, 0
    LD    E, B
    DEC   E
;Checking for collision with ball
 ;X coord
    LD    HL, ballxpos
    ADD   HL, DE
    LD    A, (HL)
    LD    B, A
    LD    A, (nibblex)
    SUB   B
    BIT   7, A
    CALL  NZ, positivize
    LD    HL, 0
    LD    B, A
    LD    L, A
    PUSH  DE
    LD    E, A
hloopnib1:
    ADD   HL, DE
    DJNZ  hloopnib1
    POP   DE
    LD    (temp), HL
 ;Y coord
    LD    HL, ballypos
    ADD   HL, DE
    LD    A, (HL)
    LD    B, A
    LD    A, (nibbley)
    SUB   B
    BIT   7, A
    CALL  NZ, positivize
    LD    HL, 0
    LD    B, A
    LD    L, A
    PUSH  DE
    LD    E, A
vloopnib1:
    ADD   HL, DE
    DJNZ  vloopnib1
    POP   DE
    EX    DE, HL
    LD    HL, (temp)
    ADD   HL, DE
    LD    A, H
    CP    0
    JR    NZ, afternib1
    LD    A, L
    CP    36
    CALL  C, nibCollide
afternib1:
    POP   BC
    DJNZ  nibLoop

playernib:
    LD    DE, 0
;Checking for collision with player
 ;X coord
    LD    A, (playerx)
    LD    B, A
    LD    A, (nibblex)
    SUB   B
    BIT   7, A
    CALL  NZ, positivize
    LD    HL, 0
    LD    B, A
    LD    L, A
    LD    E, A
hloopnib2:
    ADD   HL, DE
    DJNZ  hloopnib2
    LD    (temp), HL
 ;Y coord
    LD    A, (playery)
    LD    B, A
    LD    A, (nibbley)
    SUB   B
    BIT   7, A
    CALL  NZ, positivize
    LD    HL, 0
    LD    B, A
    LD    L, A
    LD    E, A
vloopnib2:
    ADD   HL, DE
    DJNZ  vloopnib2
    EX    DE, HL
    LD    HL, (temp)
    ADD   HL, DE
    LD    A, H
    CP    0
    JR    NZ, afternib2
    LD    A, L
    CP    49
    CALL  C, nibCollide
afternib2:
    RET

OptMenu:
    LD    HL, $0602
    LD    (CurRow), HL
    LD    HL, txt_space
    BCALL (_putS)

    LD    HL, $0402
    LD    (CurRow), HL
    LD    A, (level)
    LD    HL, 0
    LD    L, A
    BCALL (_DispHL)

    LD    A, (level)
    CP    1
    CALL  NZ, leftarrow

    LD    A, (level)
    CP    20
    CALL  NZ, rightarrow
    RET

leftarrow:
    LD    HL, $0602
    LD    (CurRow), HL
    LD    A, $CF
    BCALL (_PutMap)
    RET

rightarrow:
    LD    HL, $0902
    LD    (CurRow), HL
    LD    A, $05
    BCALL (_PutMap)
    RET

toggle_bt1:
    LD    A, 0
    LD    (bullettime), A
    RET
toggle_bt2:
    LD    A, 20
    LD    (bullettime), A
    RET
toggle_bt3:
    LD    A, 40
    LD    (bullettime), A
    RET
toggle_bt4:
    LD    A, 60
    LD    (bullettime), A
    RET
toggle_bt5:
    LD    A, 80
    LD    (bullettime), A
    RET

bullet:
    LD    A, (bullettime)
    CP    0
    RET   Z
delay1:
    DEC   A
    LD    B, 255
delay2:
    DJNZ  delay2
    CP    0
    JR    NZ, delay1
    RET

delay3:
    LD    B, 26
delay4:
    DJNZ  delay4
    CP    0
    DEC   A
    JR    NZ, delay3
    RET

myPutSprite:
;A = X
;L = Y
;B = height
;IX = pointer
    LD    H, 0
    LD    D, H
    LD    E, L
    ADD   HL, HL
    ADD   HL, DE
    ADD   HL, HL
    ADD   HL, HL
    LD    E, A
    SRL   E
    SRL   E
    SRL   E
    ADD   HL, DE
    LD    DE, PlotSScreen
    ADD   HL, DE
    LD    DE, 12
    AND   7
    JR    Z, Aligned
    LD    C, A

RowLoop:
    PUSH  BC
    LD    B, C
    LD    C, (IX)
    XOR   A
ShiftLoop:
    SRL   C
    RRA
    DJNZ  Shiftloop
    INC   HL
    XOR   (HL)
    LD    (HL), A
    DEC   HL
    LD    A, C
    XOR   (HL)
    LD    (HL), A
    ADD   HL, DE
    INC   IX
    POP   BC
    DJNZ  RowLoop
    RET
Aligned:
    LD    A, (IX)
    XOR   (HL)
    LD    (HL), A
    INC   IX
    ADD   HL, DE
    DJNZ  Aligned
    RET
s_ball:
    .DB   %01110000
    .DB   %10001000
    .DB   %10001000
    .DB   %10001000
    .DB   %01110000

s_player:
    .DB   %00111000
    .DB   %01111100
    .DB   %11111110
    .DB   %11111110
    .DB   %11111110
    .DB   %01111100
    .DB   %00111000

s_nibble:
    .DB   %00111000
    .DB   %01010100
    .DB   %10101010
    .DB   %11010110
    .DB   %10101010
    .DB   %01010100
    .DB   %00111000

titlescreen1:
    .DB   "---Dodge-ball---",0
titlescreen2:
    .DB   "      VERSION:  "
    .DB   "             2.7"
    .DB   " HIGHSCORE:     "
    .DB   "                "
    .DB   "2nd:   start    "
    .DB   "Mode:  options  "
    .DB   "Clear: exit     ", 0

;Useful words
txt_score:
    .DB   "Score:          "
    .DB   "Highscore:", 0
txt_new:
    .DB   " New Highscore! ", 0
txt_author:
    .DB   "Created by", 0
txt_author2:
    .DB   "John Tsai",0
txt_endkeys:
    .DB   "2nd:   retry    "
    .DB   "Mode:  options  "
    .DB   "Clear: exit     ", 0
txt_numballs:
    .DB   "Number of Balls", 0
txt_options:
    .DB   "L/R:   +/- balls"
    .DB   "2nd:   start    "
    .DB   "Clear: exit     ", 0
txt_space:
    .DB   "    ", 0
;highscore
highscore:
    .DB   0
.end
.end